// Larbin
// Sebastien Ailleret
// 27-05-01 -> 22-11-01

#ifndef LARBIN_CONFIG
#define LARBIN_CONFIG

#include "config.h"

//////////////////////////////////////////////////////////
// What do you want the crawler to do

// do you want to follow links in pages
#define FOLLOW_LINKS

// do you want the crawler to associate to each page the list of its sons
//#define LINKS_INFO

// do you want to save the results in files (on per page)
//#define SAVE
//#define MIRROR_SITES // require SAVE

// do you want to save specific files (allows them to be very big)
//#define SPECIFICSAVE // independant from SAVE

// do you want to associate a tag to pages (given in input)
// this allows to follow a page from input to output (and follow redirection)
//#define URL_TAGS

// do you want to suppress duplicate pages
#define NO_DUP

// do you want larbin to stop when everything has been fetched
//#define EXIT_AT_END

//////////////////////////////////////////////////////////
// Efficiency vs feature

// limit bandwith usage (in octets/sec)
// be carefull, larbin might use 10 to 20% more
//#define MAXBANDWIDTH 200000

// do we need a special thread for output
// This is compulsory if it can block
// (not needed if you did not add code yourself)
//#define THREAD_OUTPUT

// if this option is set, larbin saves the hashtable from time
// this way it can restart from where it last stopped
// by reloading the table
//#define RELOAD


//////////////////////////////////////////////////////////
// now it's just if you need to know how it works

// do you want nice graphs for in the stats page
#define GRAPH

// uncomment if you are not interested in debugging information
//#define NDEBUG

// enable this if you really dislike stats (in the webserver)
//#define NOSTATS

// enable this if you really like stats (on stdout)
//#define STATS
//#define BIGSTATS

// Please enable this option if you want to report a crash
// then compile with "make debug"
//#define CRASH

#endif // LARBIN_CONFIG
