ADNSDIR=$(BASEDIR)/../adns

UTILS-OBJ:=string.o debug.o url.o connexion.o text.o \
    histogram.o webserver.o PersistentFifo.o hashDup.o
INTERF-OBJ:=input.o output.o
FETCH-OBJ:=site.o sequencer.o hashTable.o checker.o file.o \
	fetchOpen.o fetchPipe.o
MAIN-OBJ:=global.o main.o

ABS-UTILS-OBJ:=$(patsubst %, utils/%, $(UTILS-OBJ))
ABS-INTERF-OBJ:=$(patsubst %, interf/%, $(INTERF-OBJ))
ABS-FETCH-OBJ:=$(patsubst %, fetch/%, $(FETCH-OBJ))
ABS-MAIN-OBJ:=$(MAIN-OBJ)

MAKE:=gmake
CXX:=g++
CPPFLAGS:=-Wall -O3 -D_REENTRANT -I- -I$(BASEDIR) -I$(ADNSDIR)
RM:=rm -f

first: all

dep-in:
	makedepend -f- -I$(BASEDIR) -Y *.cc 2> /dev/null > .depend

clean-in:
	$(RM) *.o
	$(RM) *~
	$(RM) *.bak

redo-in: all

debug-in: CPPFLAGS += -g
debug-in: redo-in

prof-in: CPPFLAGS += -pg -DPROF
prof-in: redo-in

-include .depend
