// Larbin
// Sebastien Ailleret
// 12-01-00 -> 28-08-01

#ifndef TYPES_H
#define TYPES_H

#include <stdlib.h>

// Size of the HashSize (max number of urls that can be fetched)
#define hashSize 64000000

// Size of the duplicate hashTable
#define dupSize hashSize
#define dupFile "dupfile.bak"

// Size of the arrays of Sites in main memory
#define namedSiteListSize 20000
#define IPSiteListSize 10000

// Max number of urls in ram
#define ramUrls 100000

// Max number of urls per site in Url
#define maxUrlsBySite 60

// time out when reading a page (in sec)
#define timeoutPage 60

// How long do we keep dns answers and robots.txt
#define dnsValidTime 2*24*3600

// Maximum size of a page
#define maxPageSize 100000

// Maximum size of a robots.txt that is read
// the value used is min(maxPageSize, maxRobotsSize)
#define maxRobotsSize 10000

// How many forbidden items do we accept in a robots.txt
#define maxRobotsItem 100

// file name used for storing urls on disk
#define fifoFile "fifo"

// number of urls per file on disk
// should be equal to ramUrls for good interaction with restart
#define urlByFile ramUrls

// Size of the buffer used to read sockets
#define BUF_SIZE 16384

// Max size for a url
#define maxUrlSize 512

// Standard size of a fifo in a Site
#define fifoSiteSize 16
#define StdVectSize 8

// maximum number of input connections
#define maxInput 5

// if we save files, how many files per directory and where
#define filesPerDir 2000
#define saveDir "save/"
#define indexFile "index.html"    // for MIRROR_SITES
#define nbDir 1000                // for MIRROR_SITES

#define specDir "specific"
#define maxSpecSize 5000000

// Various reasons of error when getting a page
#define nbAnswers 11
enum FetchError
{
  success,
  noDNS,
  noConnection,
  forbiddenRobots,
  timeout,
  badType,
  tooBig,
  err30X,
  err40X,
  earlyStop,
  duplicate
};

// standard types
typedef	unsigned int	uint;

#endif // TYPES_H
