// Larbin
// Sebastien Ailleret
// 18-11-99 -> 21-05-01

#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <iostream.h>
#include <string.h>

#include "options.h"

#include "utils/text.h"
#include "utils/string.h"

/* lowercase a char */
char lowerCase (char a) {
  if (a >= 'A' && a <= 'Z') {
    return a - 'A'+ 'a' ;
  } else {
    return a;
  }
}

/* test if b starts with a
 */
int startWith (char *a, char *b) {
  size_t la = strlen(a);
  return !strncmp(a, b, la);
}

/* test if b starts with a ignoring case
 */
int startWithIgnoreCase (char *a, char *b) {
  size_t la = strlen(a);
  return !strncasecmp(a, b, la);
}

/* test if b end with a
 */
int endWith (char *a, char *b) {
  int la = strlen(a);
  int lb = strlen(b);
  return (la <= lb) && !strcmp(a, b+lb-la);
}

/* test if b end with a ignoring case
 * a can use min char, '.' (a[i] = a[i] | 32)
 */
int endWithIgnoreCase (char *amin, char *b, int lb) {
  int la = strlen(amin);
  if (la <= lb) {
    int i;
    int diff = lb-la;
    for (i=0; i<la; i++) {
      if (amin[i] != (b[diff+i] | 32)) {
        return false;
      }
    }
    return true;
  } else {
    return false;
  }
}

/* test if b contains a */
int caseContain (char *a, char *b) {
  size_t la = strlen(a);
  int i = strlen(b) - la;
  while (i >= 0) {
	if (!strncasecmp(a, b+i, la)) {
	  return 1;
	}
	i--;
  }
  return 0;
}

/* create a copy of a string
 */
char *newString (char *arg) {
  char *res = new char[strlen(arg) + 1];
  strcpy(res, arg);
  return res;
}

/* Read a whole file
 */
char *readfile (int fds) {
  ssize_t pos = 0;
  ssize_t size = 512;
  int cont = 1;
  char buf[500];
  ssize_t nbRead;
  char *res = new char[size];
  while(cont == 1) {
	switch (nbRead = read(fds, &buf, 500)) {
	case 0 : cont = 0; break;
	case -1 : if (errno != EINTR && errno != EIO) cont = -1; break;
	default :
	  if (pos + nbRead >= size) {
		size *= 2;
		char *tmp = new char[size];
		memcpy(tmp, res, pos);
		delete res;
		res = tmp;
	  }
	  memcpy(res+pos, buf, nbRead);
	  pos += nbRead;
	  break;
	}
  }
  res[pos] = 0;
  return res;
}

/* is this char a word separator
 */
inline static int isDelim (char c) {
  return (c == ' ' || c == '\t' || c == '\n' || c == '\r');
}

/* Are we at the end of a word
 */
inline static int isNotFin (char c) {
  return (c != ' ' && c != '\t' 
		  && c != '\n' && c != '\r' && c != '\0');
}

/* next word in this string
 */
char *nextTokenStr (String &strin, uint *pos) {
  uint deb;
  while (isDelim(strin[*pos])) {
	(*pos)++;
  }
  deb = *pos;
  while (isNotFin(strin[*pos])) {
	(*pos)++;
  }
  if (deb == *pos) {
	return NULL;
  } else {
	char *res = new char[*pos - deb +1];
	for (uint i=deb; i<*pos; i++) {
	  res[i-deb] = strin[i];
	}
	res[*pos - deb] = '\0';
	return res;
  }
}

/* next word in this char *
 */
char *nextToken (char **pos) {
  while (isDelim(**pos)) {
	(*pos)++;
  }
  char *deb = *pos;
  while (isNotFin(**pos)) {
	(*pos)++;
  }
  if (deb == *pos) {
	return NULL;
  } else {
    if (**pos != 0) {
      **pos = 0;
      (*pos)++;
    }
    return deb;
  }
}

// end of text.cc
