// Larbin
// Sebastien Ailleret
// 07-03-00 -> 28-08-01

/* This is the code for the webserver which is used 
 * for giving stats about the program while it is running
 *
 * It is very UNefficient, but i don't care since it should
 * not be used very often. Optimize here is a waste of time */

#include <string.h>
#include <unistd.h>
#include <iostream.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/resource.h>

#include "options.h"

#include "global.h"
#include "fetch/fetchOpen.h"
#include "fetch/sequencer.h"
#include "utils/text.h"
#include "utils/connexion.h"
#include "utils/debug.h"
#include "utils/histogram.h"

static void readAll (int fds);
static void writeRes (int fds);

static time_t startTime;
static char *startDate;

void *startWebserver (void *none) {
  // bind the socket
  int fds;
  int nAllowReuse = 1;
  struct sockaddr_in addr;
  startTime = global::now;
  startDate = newString(ctime(&startTime));
  bzero (&addr, sizeof(addr));
  addr.sin_addr.s_addr = INADDR_ANY;
  addr.sin_family = AF_INET;
  addr.sin_port = htons(global::httpPort);
  if ((fds = socket(AF_INET, SOCK_STREAM, 0)) == -1
	  || setsockopt(fds, SOL_SOCKET, SO_REUSEADDR, (char*)&nAllowReuse, sizeof(nAllowReuse))
	  || bind(fds, (struct sockaddr *) &addr, sizeof(addr)) != 0
	  || listen(fds, 4) != 0) {
	cerr << "Unable to get the socket\n";
	exit(1);
  }
  // answer requests
  for (;;) {
	struct sockaddr_in addrc;
	int fdc;
	uint len = sizeof(addr);
	fdc = accept(fds, (struct sockaddr *) &addrc, &len);
	if (fdc == -1) {
	  cerr << "Trouble with web server...\n";
	} else {
	  readAll(fdc);
	  writeRes(fdc);
	}
  }
  return NULL;
}

static void readAll (int fds) {
  char c;
  int cont = 2;
  while (cont) {
	if (read(fds, &c, 1) == 1) { 
	  switch (c) {
	  case '\r' :
		break;
	  case '\n' :
		cont--;
		break;
	  default :
		cont = 2;
		break;
	  }
	} else {
	  cont = 0;
	}
  }
}

static void writeRes (int fds) {
  crash("Answer to a web query");
  // headers and html tags
  ecrire(fds, "HTTP/1.0 200 OK\r\nServer: Larbin\r\nContent-type: text/html\r\n\r\n<html>\n<head>\n<title>");
  ecrire(fds, global::userAgent);
  ecrire(fds, " real time statistic</title>\n</head>\n<body bgcolor=\"#FFFFFF\">\n<center><h1>Larbin is up and running !</h1></center>\n");

  ecrire(fds, "\n<pre>Start date :   ");
  ecrire(fds, startDate);
  ecrire(fds, "Current date : ");
  ecrire(fds, ctime(&global::now));
  ecrire(fds, "up: ");
  int duree = global::now - startTime;
  int totalduree = duree;
  if (duree > 86400) {
    ecrireInt(fds, duree / 86400);
    duree %= 86400;
    ecrire(fds, " day(s) ");
  }
  ecrireInt(fds, duree/3600);
  duree %= 3600;
  ecrire(fds, ":");
  ecrireInt2(fds, duree/60);
  duree %= 60;
  ecrire(fds, ":");
  ecrireInt2(fds, duree);

#ifndef NOSTATS
  if (global::isSpecific) {
    ecrire(fds, "\n\n<h2>Interesting pages (");
    ecrire(fds, global::contentType);
    ecrire(fds, ") :</h2>\n\ntotal Fetched (success)          : ");
    ecrireInti(fds, interestingPage, "%5d");
    ecrire(fds, "\ntotal Fetched (error or success) : ");
    ecrireInti(fds, interestingSeen, "%5d");
    if (global::privilegedExt != NULL) {
      ecrire(fds, "\nprivileged links seen (");
      ecrire(fds, global::privilegedExt);
      ecrire(fds, ") :     ");
      ecrireInti(fds, interestingExtension, "%5d");
      ecrire(fds, "\nprivileged links fetched :         ");
      ecrireInti(fds, extensionTreated, "%5d");
    }
  }

  ecrire(fds, "\n\n<h2>Pages :</h2>\n\nurls treated : ");
  ecrireInti(fds, urls, "%13d");
  ecrire(fds, "   (current rate : ");
  ecrireInti(fds, urlsRate, "%3d");
  ecrire(fds, ", overall rate : ");
  ecrireInti(fds, urls / totalduree, "%3d");
  ecrire(fds, ")\nforbiddenRobots : ");
  ecrireInti(fds, answers[forbiddenRobots], "%10d");
  ecrire(fds, "\nnoDNS : ");
  ecrireInti(fds, answers[noDNS], "%20d");
  ecrire(fds, "\n\nPages : ");
  ecrireInti(fds, pages, "%20d");
  ecrire(fds, "   (current rate : ");
  ecrireInti(fds, pagesRate, "%3d");
  ecrire(fds, ", overall rate : ");
  ecrireInti(fds, pages / totalduree, "%3d");
  ecrire(fds, ")\nSuccess : ");
  ecrireInti(fds, answers[success], "%18d");
  ecrire(fds, "   (current rate : ");
  ecrireInti(fds, successRate, "%3d");
  ecrire(fds, ", overall rate : ");
  ecrireInti(fds, answers[success] / totalduree, "%3d");
  ecrire(fds, ")\nno Connection : ");
  ecrireInti(fds, answers[noConnection], "%12d");
  ecrire(fds, "\nearly stop : ");
  ecrireInti(fds, answers[earlyStop], "%15d");
  ecrire(fds, "\ntimeout : ");
  ecrireInti(fds, answers[timeout], "%18d");
  ecrire(fds, "\nbadType : ");
  ecrireInti(fds, answers[badType], "%18d");
  ecrire(fds, "\ntooBig : ");
  ecrireInti(fds, answers[tooBig], "%19d");
  ecrire(fds, "\nerr30X : ");
  ecrireInti(fds, answers[err30X], "%19d");
  ecrire(fds, "\nerr40X : ");
  ecrireInti(fds, answers[err40X], "%19d");
#ifdef NO_DUP
  ecrire(fds, "\nduplicate : ");
  ecrireInti(fds, answers[duplicate], "%16d");
#endif // NO_DUP
  ecrire(fds, "\n\nurls accepted : ");
  ecrireInt(fds, hashUrls);
  ecrire(fds, " / ");
  ecrireInt(fds, hashSize);

  ecrire(fds, "\n\n<h2>Sites seen (dns call done) :</h2>\n\ntotal number : ");
  ecrireInti(fds, siteSeen, "%18d");
  ecrire(fds, " +");
  ecrireInti(fds, nbCalls, "%2d");
  ecrire(fds, "   (current rate : ");
  ecrireInti(fds, siteSeenRate, "%2d");
  ecrire(fds, ", overall rate : ");
  ecrireInti(fds, siteSeen / totalduree, "%2d");
  ecrire(fds, ")\nwith dns : ");
  ecrireInti(fds, siteDNS, "%22d");
  ecrire(fds, "       (current rate : ");
  ecrireInti(fds, siteDNSRate, "%2d");
  ecrire(fds, ", overall rate : ");
  ecrireInti(fds, siteDNS / totalduree, "%2d");
  ecrire(fds, ")\nwith robots.txt : ");
  ecrireInti(fds, siteRobots, "%15d");
  ecrire(fds, "\nwith good robots.txt : ");
  ecrireInti(fds, robotsOK, "%10d");

  ecrire(fds, "\n\nsites ready      : ");
  ecrireInti(fds,
			global::okSites->getLength()
			+ global::nb_conn
			- global::freeConns->getLength(), "%5d");
  ecrire(fds, "\nsites without ip : ");
  ecrireInti(fds, global::dnsSites->getLength(), "%5d");
#ifdef GRAPH
  ecrire(fds, "\n\n<h2>Histograms :</h2>");
  histoWrite(fds);
#endif // GRAPH
#endif // NOSTATS

#ifndef NDEBUG
  ecrire(fds, "\n\n<h2>Ressources Sharing :</h2>\n\nused connexions : ");
  ecrireInti(fds, global::nb_conn - global::freeConns->getLength(), "%8d");
#ifdef THREAD_OUTPUT
  ecrire(fds, "\nuser connexions : ");
  ecrireInti(fds, global::userConns->getLength(), "%8d");
#endif
  ecrire(fds, "\nfree connexions : ");
  ecrireInti(fds, global::freeConns->getLength(), "%8d");
  ecrire(fds, "\nparsers         : ");
  ecrireInti(fds, debPars, "%8d");
  ecrire(fds, "\n\nsites in ram    : ");
  ecrireInti(fds, sites, "%8d");
  ecrire(fds, "\nipsites in ram  : ");
  ecrireInti(fds, ipsites, "%8d");
  ecrire(fds, "\nurls in ram     : ");
  ecrireInti(fds, debUrl, "%8d");
  ecrire(fds, "   (");
  ecrireInt(fds, global::inter->getPos() - space);
  ecrire(fds, ")\nurls on disk    : ");
  ecrireInti(fds, global::URLsInternal->getLength(), "%8d");
  ecrire(fds, "\nmiss urls       : ");
  ecrireInti(fds, missUrl, "%8d");

  ecrire(fds, "\n\nreceive : ");
  ecrireIntl(fds, byte_read, "%12lu");
  ecrire(fds, "   (current rate : ");
  ecrireIntl(fds, readRate, "%7lu");
  ecrire(fds, ", overall rate : ");
  ecrireIntl(fds, byte_read / totalduree, "%7lu");
  ecrire(fds, ")\nemit    : ");
  ecrireIntl(fds, byte_write, "%12lu");
  ecrire(fds, "   (current rate : ");
  ecrireIntl(fds, writeRate, "%7lu");
  ecrire(fds, ", overall rate : ");
  ecrireIntl(fds, byte_write / totalduree, "%7lu");

  ecrire(fds, ")\n\nstateMain : ");
  ecrireInt(fds, stateMain);
  ecrire(fds, "\ndebug     : ");
  ecrireInt(fds, debug);

#ifdef HAS_PROC_SELF_STATUS
  ecrire(fds, "\n\n<h2>/proc/self/status :</h2>\n");
  int status = open("/proc/self/status", O_RDONLY);
  char *file = readfile(status);
  ecrire(fds, file);
  delete [] file;
  close(status);
#endif // HAS_PROC_SELF_STATUS

  ecrire(fds, "</pre>");  
#endif // NDEBUG

  // end of page and kill the connexion
  ecrire(fds, "\n<hr>\n<A HREF=\"http://pauillac.inria.fr/~ailleret/\"><img SRC=\"http://pauillac.inria.fr/~ailleret/seb.gif\" ALT=\"ma photo\"></A>\n<A HREF=\"mailto:sebastien.ailleret@inria.fr\">sebastien.ailleret@inria.fr</A>\n</body>\n</html>");
  shutdown(fds, 2);
  close(fds);
}
